//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  Silver
#property indicator_color4  LimeGreen
#property indicator_color5  LimeGreen
#property indicator_color6  PaleVioletRed
#property indicator_color7  PaleVioletRed
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_width3  2
#property indicator_width4  3
#property indicator_width5  3
#property indicator_width6  3
#property indicator_width7  3

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern int    StoKPeriod  = 14;
extern int    StoSlowing  =  3;
extern int    StoPrice    =  0;
extern int    LongPeriod  = 50;
extern double Percent     = 95;
extern bool   Interpolate = true;

//
//
//
//
//

double sto[];
double leu[];
double led[];
double stoUa[];
double stoUb[];
double stoDa[];
double stoDb[];
double state[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,leu);
   SetIndexBuffer(1,led);
   SetIndexBuffer(2,sto);
   SetIndexBuffer(3,stoUa);
   SetIndexBuffer(4,stoUb);
   SetIndexBuffer(5,stoDa);
   SetIndexBuffer(6,stoDb);
   SetIndexBuffer(7,state);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+" Stochastic ("+StoKPeriod+","+StoSlowing+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { leu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (state[limit] ==-1) CleanPoint(limit,stoDa,stoDb);
      if (state[limit] == 1) CleanPoint(limit,stoUa,stoUb);

      for(i=limit; i>=0; i--) 
      {
         sto[i] = iStochastic(NULL,0,StoKPeriod,1,StoSlowing,MODE_SMA,StoPrice,MODE_MAIN  ,i);
            double hi = sto[ArrayMaximum(sto,LongPeriod,i)];
            double lo = sto[ArrayMinimum(sto,LongPeriod,i)];
            double rn = hi-lo;
         leu[i]   = lo+rn*Percent/100.0;
         led[i]   = hi-rn*Percent/100.0;
         stoUa[i] = EMPTY_VALUE;
         stoUb[i] = EMPTY_VALUE;
         stoDa[i] = EMPTY_VALUE;
         stoDb[i] = EMPTY_VALUE;
         state[i] = state[i+1];
            if (sto[i] > leu[i])                    state[i] =  1;
            if (sto[i] < led[i])                    state[i] = -1;
            if (sto[i] < leu[i] && sto[i] > led[i]) state[i] =  0;
            if (state[i] == 1) PlotPoint(i,stoUa,stoUb,sto);
            if (state[i] ==-1) PlotPoint(i,stoDa,stoDb,sto);
      }      
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (state[limit] ==-1) CleanPoint(limit,stoDa,stoDb);
   if (state[limit] == 1) CleanPoint(limit,stoUa,stoUb);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         leu[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StoKPeriod,StoSlowing,StoPrice,LongPeriod,Percent,0,y);
         led[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StoKPeriod,StoSlowing,StoPrice,LongPeriod,Percent,1,y);
         sto[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StoKPeriod,StoSlowing,StoPrice,LongPeriod,Percent,2,y);
         state[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StoKPeriod,StoSlowing,StoPrice,LongPeriod,Percent,7,y);
         stoUa[i] = EMPTY_VALUE;
         stoUb[i] = EMPTY_VALUE;
         stoDa[i] = EMPTY_VALUE;
         stoDb[i] = EMPTY_VALUE;

         //
         //
         //
         //
         //
      
         if (Interpolate<1 || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
             interpolate(leu,timeFrame,i,Interpolate);
             interpolate(led,timeFrame,i,Interpolate);
             interpolate(sto,timeFrame,i,Interpolate);
   }
   for (i=limit; i>=0; i--)
   {
      if (state[i] == 1) PlotPoint(i,stoUa,stoUb,sto);
      if (state[i] ==-1) PlotPoint(i,stoDa,stoDb,sto);
   }
   return(0);
   
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void interpolate(double& target[], int timeFrame, int i, int interpolateType)
{
   int t = iBarShift(NULL,timeFrame,Time[i]); 
      double y0 = target[i];
      double y1 = target[iBarShift(NULL,0,iTime(NULL,timeFrame,t+0))+1];
      double y2 = target[iBarShift(NULL,0,iTime(NULL,timeFrame,t+1))+1];

      //
      //
      //
      //
      //
      
      datetime time = iTime(NULL,timeFrame,t);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
         for(int k = 1; k < n; k++)
         if (interpolateType==2)
         {
            double x3 = 1.0*k/n;
               target[i+k]  = y0*(x3-1.0)*(x3-2.0)/(-1.0*(-2.0))+
                              y1*(x3-0.0)*(x3-2.0)/( 1.0*(-1.0))+
		                        y2*(x3-0.0)*(x3-1.0)/( 2.0*( 1.0));         
         }
         else target[i+k] = target[i] + (target[i+n] - target[i])*k/n;
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}